// EntropyPool.h: interface for the CEntropyPool class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ENTROPYPOOL_H__04C1AB79_DFA9_41DD_A1E2_277699F66A64__INCLUDED_)
#define AFX_ENTROPYPOOL_H__04C1AB79_DFA9_41DD_A1E2_277699F66A64__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CEntropyPool  
{
public:
	CEntropyPool();
	virtual ~CEntropyPool();

	void Reset();

	void AddData(int nData, unsigned int nEntropyBits);
	void AddData(void *pData, size_t nSize, unsigned int nEntropyBits);

	static unsigned int ApproxateEntropy(unsigned int nValue, unsigned int nMaxBitsEntropy = 4);

	BYTE *GetData() { return m_pData; }
	size_t GetDataSize() { return m_nDataSize; }

	unsigned long GetEntropyBits() { return m_nEntropyBits; }

protected:
	void Grow(size_t nGrowBy);

	BYTE *m_pData;
	size_t m_nBufSize;
	size_t m_nDataSize;
	unsigned long m_nEntropyBits;


};

#endif // !defined(AFX_ENTROPYPOOL_H__04C1AB79_DFA9_41DD_A1E2_277699F66A64__INCLUDED_)
