// RandGenDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RandGen.h"
#include "RandGenDlg.h"

#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRandGenDlg dialog

CRandGenDlg::CRandGenDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRandGenDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRandGenDlg)
	m_nBytesRequired = 32;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRandGenDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRandGenDlg)
	DDX_Control(pDX, IDC_COMBO, m_ctrlOutputFormat);
	DDX_Control(pDX, IDC_PROGRESS, m_ProgressBar);
	DDX_Text(pDX, IDC_EDIT_BYTES_REQD, m_nBytesRequired);
	DDV_MinMaxInt(pDX, m_nBytesRequired, 1, 100000);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRandGenDlg, CDialog)
	//{{AFX_MSG_MAP(CRandGenDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_GO, OnGo)
	ON_WM_MOUSEMOVE()
	ON_WM_DESTROY()
	ON_CBN_SELCHANGE(IDC_COMBO, OnSelchangeOutputFormat)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRandGenDlg message handlers

BOOL CRandGenDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_dwSamplePeriod = 20;
	m_pOutputRandomData = NULL;
	m_bTestActive = false;
	m_nResultsSizeBytes = 0;
	m_ctrlOutputFormat.SetCurSel(0);

	// sha-1 has 160 bit output
	m_nBitsPerOutputBlock = 160;		// for SHA-1 = 160
	m_nBytesPerOutputBlock = m_nBitsPerOutputBlock / 8;
	m_nInputEntropyPerBlock = 2 * m_nBitsPerOutputBlock + 20;	// 2x safety margin.  Completely arbitrary

	// timers
	timeBeginPeriod(1);
	SetTimer(1234, 50, NULL);
	srand(timeGetTime());

	// make sure we can access the performance counter
	LARGE_INTEGER Count;
	if (!QueryPerformanceCounter(&Count)) {
		AfxMessageBox("Performance counter not available.  Cannot continue.");
		return FALSE;
	}
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRandGenDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRandGenDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRandGenDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRandGenDlg::OnTimer(UINT nIDEvent) 
{
	if (!m_bTestActive) {
		m_ProgressBar.SetPos(0);
	}

	CDialog::OnTimer(nIDEvent);
}

void CRandGenDlg::OnGo() 
{
	if (m_bTestActive) {
		CompleteTest(false);
		return;
	}

	if (!UpdateData(TRUE))
		return;

	StartEntropyBlock();
	m_bTestActive = true;
	m_dwLastTime = timeGetTime();
	m_dwGenStartTime = m_dwLastTime;
	srand(m_dwLastTime);

	m_nResultsSizeBytes = 0;
	delete [] m_pOutputRandomData;
	m_nBlocksRequired = (m_nBytesRequired + (m_nBytesPerOutputBlock - 1)) / m_nBytesPerOutputBlock;
	m_pOutputRandomData = new BYTE[m_nBlocksRequired * m_nBytesPerOutputBlock];

	m_bFirstMovement = true;
	m_ptMouseDist.x = 0;
	m_ptMouseDist.y = 0;
	m_nCurBlockNum = 0;

	m_ProgressBar.SetRange32(0, m_nBlocksRequired * m_nInputEntropyPerBlock);
	m_ProgressBar.SetPos(0);

	GetDlgItem(IDC_EDIT_RESULT)->SetWindowText("");
	GetDlgItem(IDC_EDIT_RESULT)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_STATS)->EnableWindow(FALSE);
	GetDlgItem(IDC_STATIC_PROGRESS)->SetWindowText("Please move the mouse randomly...");
	GetDlgItem(IDC_BUTTON_GO)->SetWindowText("Cancel");
	GetDlgItem(IDC_EDIT_BYTES_REQD)->EnableWindow(FALSE);
	GetDlgItem(IDC_COMBO)->EnableWindow(FALSE);	

	// let them move a bit before we start taking readings
	{
		CWaitCursor wc;
		Sleep(250);
	}
}

void CRandGenDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	LARGE_INTEGER Count;
	DWORD dwNow = timeGetTime();
	unsigned int nApproxEntropy;

	if (!m_bTestActive)
		return;

	if (m_bFirstMovement) {
		m_ptMouseDist.x = 0;
		m_ptMouseDist.y = 0;
		m_nNumMovements = 0;
		m_nDirChanges = 0;
		m_ptMouseLastSample = point;
	}
	else if ((dwNow - m_dwLastTime) > m_dwSamplePeriod) {

		// move enough?
		int nDist = m_ptMouseDist.x + m_ptMouseDist.y;
		if ((nDist > 50) && (m_nDirChanges > 0)) {

			TRACE("Dist %d,  Dir Changes %d,  Moves %d\n", nDist, m_nDirChanges, m_nNumMovements);

			// enough movement occurred: Mix x & y pos
			// Each axis should give at least 3 bits of entropy.
			m_EntropyPool.AddData(point.x, 3);
			m_EntropyPool.AddData(point.y, 3);

			// mix in distance traveled.  Up to 5 bits entropy, depending on magnitude.
			// Note that distance really is velocity, since the time period is (mostly) fixed
			nApproxEntropy = CEntropyPool::ApproxateEntropy(nDist, 4) + 1;
			m_EntropyPool.AddData(nDist, nApproxEntropy);

			// mix in the number of movements.  Up to 2 bits entropy, depending on magnitude.
			nApproxEntropy = CEntropyPool::ApproxateEntropy(m_nNumMovements, 2);
			m_EntropyPool.AddData(m_nNumMovements, nApproxEntropy);
			m_nNumMovements = 0;

			// mix in the number of direction changes.  Up to 2 bits entropy, depending on magnitude.
			nApproxEntropy = CEntropyPool::ApproxateEntropy(m_nDirChanges, 2);
			m_EntropyPool.AddData(m_nDirChanges, nApproxEntropy);
			m_nDirChanges = 0;

			// mix in the microsecond counter.  Approx 4 bits entropy.
			QueryPerformanceCounter(&Count);
			m_EntropyPool.AddData((int)Count.QuadPart, 4);

			// calculate and mix in the average angle.  Approx 2 bits entropy.
			CPoint ptAveDir = m_ptMouseLastSample - point;
			int Angle = (int)(1000 * atan((double)ptAveDir.y / ptAveDir.x));
			m_EntropyPool.AddData(Angle, 2);
			m_ptMouseLastSample = point;

			// signal new data avail
			NewDataAdded();

			// vary the sample period a bit
			m_dwSamplePeriod = 55 + nDist % 7 + rand() % 3 + (int)Count.QuadPart % 4;

		}
		
		m_ptMouseDist.x = 0;
		m_ptMouseDist.y = 0;
		m_dwLastTime = dwNow;

	}
	else {
		bool bDir;
		CPoint ptDiff = point - m_ptMousePrev;

		// check x direction
		if (ptDiff.x != 0) {
			bDir = ptDiff.x > 0;
			if (bDir != m_bXDir) {
				// direction changed:
				m_bXDir = bDir;
				DirectionChanged(point);
			}
		}

		// check y direction
		if (ptDiff.y != 0) {
			bDir = ptDiff.y > 0;
			if (bDir != m_bYDir) {
				// direction changed:
				m_bYDir = bDir;
				DirectionChanged(point);
			}
		}

		m_ptMouseDist.x += abs(ptDiff.x);
		m_ptMouseDist.y += abs(ptDiff.y);
		m_nNumMovements++;
	}
	m_ptMousePrev = point;
	m_bFirstMovement = false;
	
	CDialog::OnMouseMove(nFlags, point);
}

void CRandGenDlg::DirectionChanged(CPoint point)
{
	static CPoint ptLast; 
	static DWORD dwLast = timeGetTime();
	DWORD dwNow = timeGetTime();
	DWORD dwDelta = dwNow - dwLast;

	// keep track of direction changes
	m_nDirChanges++;

	// only count the dir change as entropy if there was enough movment
	CPoint ptDist = point - ptLast;
	int nDistance = abs(ptDist.x) + abs(ptDist.y);
//	TRACE("Dirchange dist %d\n", nDistance);
	int nEntropy = 0;
	if (nDistance > 20) {
		nEntropy = CEntropyPool::ApproxateEntropy(nDistance, 4);
	}

	// Record the time of direction changes.  Up to 4 bits entropy.
	LARGE_INTEGER Count;
	QueryPerformanceCounter(&Count);
	m_EntropyPool.AddData((int)Count.QuadPart, nEntropy);
	m_EntropyPool.AddData(dwNow, 0);

	// keep track of prev
	dwLast = dwNow;
	ptLast = point;

	// signal new data avail
	NewDataAdded();
}

void CRandGenDlg::NewDataAdded()
{
	// enough data?
	if (m_EntropyPool.GetEntropyBits() >= m_nInputEntropyPerBlock) {
		EntropyBlockComplete();
	}
	
	// display progress
	m_ProgressBar.SetPos(m_EntropyPool.GetEntropyBits() + m_nCurBlockNum * m_nInputEntropyPerBlock);
}

int Count1s(BYTE In)
{
	BYTE Count = 0;
	BYTE Mask = 1;

	for (int i = 0; i < 8; i++, Mask <<=1) {
		if (In & Mask)
			Count++;
	}

	return Count;
}

void CRandGenDlg::StartEntropyBlock()
{
	static unsigned int nCounter = 0;
	LARGE_INTEGER microsecond;

	m_EntropyPool.Reset();

	// start with the current time to give us a few bits
	QueryPerformanceCounter(&microsecond);
	m_EntropyPool.AddData(&microsecond, sizeof(microsecond), 4);
	m_EntropyPool.AddData(timeGetTime(), 0);
	m_EntropyPool.AddData((int)time(NULL), 0);
	m_EntropyPool.AddData(nCounter++, 0);
}

void CRandGenDlg::EntropyBlockComplete()
{
	// perform a SHA1 hash on our entropy pool
	SHA1Context sha;
	SHA1Reset(&sha);
	SHA1Input(&sha, m_EntropyPool.GetData(), m_EntropyPool.GetDataSize());
	SHA1Result(&sha);

	// add it to the output
	ASSERT(sizeof(sha.Message_Digest) == m_nBytesPerOutputBlock);
	memcpy(m_pOutputRandomData + (m_nCurBlockNum * m_nBytesPerOutputBlock), sha.Message_Digest, m_nBytesPerOutputBlock);
	m_nCurBlockNum++;

	if (m_nCurBlockNum >= m_nBlocksRequired)
		CompleteTest(true);
	else
		StartEntropyBlock();
}


void CRandGenDlg::CompleteTest(bool bSuccess)
{
	int i;
	CString s, sTemp;
	int nTempOnes;
	int nOnes = 0;
	int nZeros = 0;
	static int nOnesCum = 0;
	static int nZerosCum = 0;
	static int nBitsCum = 0;
	int nBits = m_nBytesRequired * 8;
	int nRawBitsGenerated = m_nBitsPerOutputBlock * m_nBlocksRequired;

	if (bSuccess) {
		nBitsCum += nBits;

		// stats
		for (i = 0; i < m_nBytesRequired; i++) {
			nTempOnes = Count1s(m_pOutputRandomData[i]);
			nOnes += nTempOnes;
			nZeros += (8 - nTempOnes);
			nOnesCum += nTempOnes;
			nZerosCum += (8 - nTempOnes);
		}

		m_nResultsSizeBytes = m_nBytesRequired;
	}
	DisplayResults();

	GetDlgItem(IDC_EDIT_RESULT)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_STATS)->EnableWindow(TRUE);
	GetDlgItem(IDC_COMBO)->EnableWindow(TRUE);	

	if (bSuccess)
		GetDlgItem(IDC_STATIC_PROGRESS)->SetWindowText("Generation complete.  Results below.");
	else
		GetDlgItem(IDC_STATIC_PROGRESS)->SetWindowText("Generation canceled.");
	m_bTestActive = false;

	// format stats
	s.Empty();
	if (bSuccess) {
		DWORD dwTime = timeGetTime() - m_dwGenStartTime;
		sTemp.Format("Generation speed: %lu bits / second\r\n\r\n", nRawBitsGenerated * 1000 / dwTime);
		s += sTemp;

		sTemp.Format("Digit counts (this number):\r\n");
		s += sTemp;
		sTemp.Format(" Number of 1's: %lu (%.2f%%)\r\n", nOnes, (float)nOnes / nBits * 100);
		s += sTemp;
		sTemp.Format(" Number of 0's: %lu (%.2f%%)\r\n", nZeros, (float)nZeros / nBits * 100);
		s += sTemp;
	}
	if (nBitsCum > 0) {
		sTemp.Format("\r\nDigit counts (cumulative):\r\n");
		s += sTemp;
		sTemp.Format(" Number of 1's: %lu (%.3f%%)\r\n", nOnesCum, (float)nOnesCum / nBitsCum * 100);
		s += sTemp;
		sTemp.Format(" Number of 0's: %lu (%.3f%%)\r\n", nZerosCum, (float)nZerosCum / nBitsCum * 100);
		s += sTemp;
	}
	GetDlgItem(IDC_EDIT_STATS)->SetWindowText(s);
	GetDlgItem(IDC_BUTTON_GO)->SetWindowText("Go!");
	GetDlgItem(IDC_EDIT_BYTES_REQD)->EnableWindow(TRUE);
}

void CRandGenDlg::DisplayResults()
{
	unsigned int i,j;
	int nFormat;
	CString s, sTemp;
	CString sSeparator = " ";
	const char Base64Lookup[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	BYTE nTempVal;

	UpdateData();
	nFormat = m_ctrlOutputFormat.GetCurSel();

	for (i = 0; i < m_nResultsSizeBytes; i++) 
	{
		sTemp.Empty();
		switch (nFormat)
		{
		case 0:	// raw bytes
			if ((i > 0) && ((i % 32) == 0))
				s += "\r\n";
			sTemp.Format("%02X", m_pOutputRandomData[i]);
			break;

		case 1:	// raw bits
			if ((i > 0) && ((i % 8) == 0))
				s += "\r\n";
			for (j = 0; j < 8; j++)
			{
				if (m_pOutputRandomData[i] & (1 << (7-j)))
					sTemp += "1";
				else
					sTemp += "0";
			}
			sTemp += sSeparator;
			break;

		case 2:	// "C" code
			if ((i > 0) && ((i % 16) == 0))
				s += "\r\n";
			sTemp.Format("0x%02X,%s", m_pOutputRandomData[i], sSeparator);
			break;

		case 3:	// "C" code, little endian words
			if ((i > 0) && ((i % 16) == 0))
				s += "\r\n";
			nTempVal = 0;
			if ((i + 1) < m_nResultsSizeBytes)
				nTempVal = m_pOutputRandomData[i+1];
			sTemp.Format("0x%02X%02X,%s", nTempVal, m_pOutputRandomData[i], sSeparator);
			i++;	// two bytes at a time

			break;

		case 4:	// Base 64-ish
			
			if ((i > 0) && ((i % 64) == 0)) {
				s += "\r\n";
			}
			nTempVal = m_pOutputRandomData[i]%64;
			sTemp.Format("%c", Base64Lookup[nTempVal], sSeparator);
			break;

		case 5:	// Binary
			
			nTempVal = m_pOutputRandomData[i];
			sTemp.Format("%c", nTempVal);
			break;

		}

		s += sTemp;
	}

	GetDlgItem(IDC_EDIT_RESULT)->SetWindowText(s);
}

void CRandGenDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	delete [] m_pOutputRandomData;
		
}



void CRandGenDlg::OnSelchangeOutputFormat() 
{
	DisplayResults();
}

void CRandGenDlg::OnChangeEditSeparator() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	DisplayResults();
	
}
