// RandGenDlg.h : header file
//

#if !defined(AFX_RANDGENDLG_H__A0FA10FB_5BFC_4873_8BF8_EE38C1311F64__INCLUDED_)
#define AFX_RANDGENDLG_H__A0FA10FB_5BFC_4873_8BF8_EE38C1311F64__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "sha1.h"
#include "EntropyPool.h"

/////////////////////////////////////////////////////////////////////////////
// CRandGenDlg dialog

class CRandGenDlg : public CDialog
{
// Construction
public:
	CRandGenDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CRandGenDlg)
	enum { IDD = IDD_RANDGEN_DIALOG };
	CComboBox	m_ctrlOutputFormat;
	CProgressCtrl	m_ProgressBar;
	int		m_nBytesRequired;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRandGenDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CRandGenDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnGo();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnDestroy();
	afx_msg void OnSelchangeOutputFormat();
	afx_msg void OnChangeEditSeparator();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	void DirectionChanged(CPoint point);
	void NewDataAdded();
	void StartEntropyBlock();
	void EntropyBlockComplete();
	void CompleteTest(bool bSuccess);
	void DisplayResults();

	CEntropyPool m_EntropyPool;
	BYTE *m_pOutputRandomData;
	size_t m_nOutputSizeBytes;
	size_t m_nResultsSizeBytes;

	bool m_bTestActive;

	DWORD m_dwGenStartTime;
	DWORD m_dwLastTime;
	DWORD m_dwSamplePeriod;
	CPoint m_ptMouseDist;
	CPoint m_ptMousePrev;
	CPoint m_ptMouseLastSample;
	int m_nNumMovements;
	int m_nDirChanges;

	bool m_bFirstMovement;
	int m_nBlocksRequired;
	int m_nCurBlockNum;

	bool m_bXDir;
	bool m_bYDir;

	unsigned int m_nBitsPerOutputBlock;		// for SHA-1 = 160
	unsigned int m_nBytesPerOutputBlock;	// for SHA-1 = 160/8 = 20
	unsigned int m_nInputEntropyPerBlock;	// should be >= m_nBitsPerOutputBlock

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RANDGENDLG_H__A0FA10FB_5BFC_4873_8BF8_EE38C1311F64__INCLUDED_)
