// RandGenDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RandGen.h"
#include "RandGenDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRandGenDlg dialog

CRandGenDlg::CRandGenDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRandGenDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRandGenDlg)
	m_nBytesRequired = 32;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRandGenDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRandGenDlg)
	DDX_Control(pDX, IDC_PROGRESS, m_ProgressBar);
	DDX_Text(pDX, IDC_EDIT_BYTES_REQD, m_nBytesRequired);
	DDV_MinMaxInt(pDX, m_nBytesRequired, 1, 256);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRandGenDlg, CDialog)
	//{{AFX_MSG_MAP(CRandGenDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_GO, OnGo)
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRandGenDlg message handlers

BOOL CRandGenDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_dwSamplePeriod = 20;
	m_pRandomData = NULL;
	m_bTestActive = false;
	m_nOversamplesRequired = 4;

	timeBeginPeriod(1);

	SetTimer(1234, 50, NULL);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRandGenDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRandGenDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRandGenDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRandGenDlg::OnTimer(UINT nIDEvent) 
{
	if (!m_bTestActive) {
		m_ProgressBar.SetPos(0);
	}

	CDialog::OnTimer(nIDEvent);
}

void CRandGenDlg::OnGo() 
{
	m_EntropyPool.Reset();
	m_EntropyPool.AddData("The quick brown fox ", 20, 1);
	m_EntropyPool.AddData("jumps over", 10, 1);
	m_EntropyPool.AddData(" the lazy dog", 13, 1);

	SHA1Context sha;
	SHA1Reset(&sha);
	SHA1Input(&sha, m_EntropyPool.GetData(), m_EntropyPool.GetDataSize());
	SHA1Result(&sha);

	for (int i = 0; i < 5; i++) {
		TRACE(" %X", sha.Message_Digest[i]);
	}

	if (m_bTestActive) {
		CompleteTest(false);
		return;
	}

	if (!UpdateData(TRUE))
		return;

	m_bTestActive = true;
	m_dwLastTime = timeGetTime();
	srand(m_dwLastTime);

	delete [] m_pRandomData;
	m_pRandomData = new BYTE[m_nBytesRequired];

	m_bFirstMovement = true;
	m_ptMouseDist.x = 0;
	m_ptMouseDist.y = 0;
	m_nCurDataLength = 0;
	m_nOversampleCount = 0;
	m_ProgressBar.SetRange(0, m_nBytesRequired * m_nOversamplesRequired);
	m_ProgressBar.SetPos(0);

	GetDlgItem(IDC_EDIT_RESULT)->SetWindowText("");
	GetDlgItem(IDC_EDIT_RESULT)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_STATS)->EnableWindow(FALSE);
	GetDlgItem(IDC_STATIC_PROGRESS)->SetWindowText("Please move the mouse randomly...");
	GetDlgItem(IDC_BUTTON_GO)->SetWindowText("Cancel");
	GetDlgItem(IDC_EDIT_BYTES_REQD)->EnableWindow(FALSE);

}

BYTE FlipByte(BYTE In)
{
	BYTE Out = 0;
	BYTE Mask = 1;

	for (int i = 0; i < 8; i++, Mask <<=1, In <<= 1) {
		if (In & 0x80)
			Out |= Mask;
	}

	return Out;
}

BYTE RotateByte(BYTE In, int nPos)
{
	BYTE nValue = In << nPos;
	nValue |= In >> (8 - nPos % 8);

	return nValue;
}

void CRandGenDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	LARGE_INTEGER Count;
	DWORD dwNow = timeGetTime();

	if (!m_bTestActive)
		return;

	if (m_bFirstMovement) {
		m_ptMouseDist.x = 0;
		m_ptMouseDist.y = 0;
		m_nNumMovements = 0;
	}
	else if ((dwNow - m_dwLastTime) > m_dwSamplePeriod) {

		// move enough?
		int nDist = (m_ptMouseDist.x * m_ptMouseDist.x + m_ptMouseDist.y * m_ptMouseDist.y);
		if (nDist > 345) {

			TRACE("Dist %d\n", nDist);

			// enough movement occurred: Mix x & y pos
			BYTE RandByte = (BYTE)(FlipByte((BYTE)point.x) ^ (point.y));

			// mix in distance traveled
			RandByte = (BYTE)(RandByte ^ nDist);

			// mix in the number of movements
			RandByte = (BYTE)(RandByte ^ m_nNumMovements);

			// mix in the counter
			if (!QueryPerformanceCounter(&Count)) {
				AfxMessageBox("Performance counter not available.  Cannot continue.");
				exit(1);
			}
			RandByte = (BYTE)(RandByte ^ (BYTE)(Count.QuadPart));

			// mix in pseudo-random values
			srand((int)Count.QuadPart);
			RandByte = (BYTE)(RandByte ^ rand());
			RandByte = (BYTE)(RandByte ^ FlipByte((BYTE)rand()));

			// add it to the data
			m_pRandomData[m_nCurDataLength++] ^= RotateByte(RandByte, m_nOversampleCount);
			if (m_nCurDataLength >= m_nBytesRequired) {
				m_nOversampleCount++;
				m_nCurDataLength = 0;
				if (m_nOversampleCount >= m_nOversamplesRequired)
					CompleteTest(true);
			}
		
			// display progress
			m_ProgressBar.SetPos(m_nCurDataLength + m_nOversampleCount * m_nBytesRequired);

			// vary the sample period a bit
			m_dwSamplePeriod = 35 + nDist % 7 + rand() % 3 + RandByte % 5;

		}
		
		m_ptMouseDist.x = 0;
		m_ptMouseDist.y = 0;
		m_dwLastTime = dwNow;

	}
	else {
		CPoint ptDiff = point - m_ptMousePrev;
		m_ptMouseDist.x += abs(ptDiff.x);
		m_ptMouseDist.y += abs(ptDiff.y);
		m_nNumMovements++;
	}
	m_ptMousePrev = point;
	m_bFirstMovement = false;
	
	CDialog::OnMouseMove(nFlags, point);
}

int Count1s(BYTE In)
{
	BYTE Count = 0;
	BYTE Mask = 1;

	for (int i = 0; i < 8; i++, Mask <<=1) {
		if (In & Mask)
			Count++;
	}

	return Count;
}

void CRandGenDlg::CompleteTest(bool bSuccess)
{
	int i;
	CString s, sTemp;
	int nTempOnes;
	int nOnes = 0;
	int nZeros = 0;
	static int nOnesCum = 0;
	static int nZerosCum = 0;
	static int nBitsCum = 0;
	int nBits = m_nBytesRequired * 8;

	if (bSuccess) {
		nBitsCum += nBits;

		for (i = 0; i < m_nBytesRequired; i++) {
			if ((i > 0) && ((i % 16) == 0))
				s += "\r\n";

			sTemp.Format("%02X ", m_pRandomData[i]);
			s += sTemp;

			// stats
			nTempOnes = Count1s(m_pRandomData[i]);
			nOnes += nTempOnes;
			nZeros += (8 - nTempOnes);
			nOnesCum += nTempOnes;
			nZerosCum += (8 - nTempOnes);
		}
	}
	GetDlgItem(IDC_EDIT_RESULT)->SetWindowText(s);
	GetDlgItem(IDC_EDIT_RESULT)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_STATS)->EnableWindow(TRUE);
	if (bSuccess)
		GetDlgItem(IDC_STATIC_PROGRESS)->SetWindowText("Generation complete.  Results below.");
	else
		GetDlgItem(IDC_STATIC_PROGRESS)->SetWindowText("Generation canceled.");
	m_bTestActive = false;

	// format stats
	s.Empty();
	if (bSuccess) {
		sTemp.Format("Digit counts (this number):\r\n");
		s += sTemp;
		sTemp.Format(" Number of 1's: %lu (%.2f%%)\r\n", nOnes, (float)nOnes / nBits * 100);
		s += sTemp;
		sTemp.Format(" Number of 0's: %lu (%.2f%%)\r\n", nZeros, (float)nZeros / nBits * 100);
		s += sTemp;
	}
	if (nBitsCum > 0) {
		sTemp.Format("\r\nDigit counts (cumulative):\r\n");
		s += sTemp;
		sTemp.Format(" Number of 1's: %lu (%.3f%%)\r\n", nOnesCum, (float)nOnesCum / nBitsCum * 100);
		s += sTemp;
		sTemp.Format(" Number of 0's: %lu (%.3f%%)\r\n", nZerosCum, (float)nZerosCum / nBitsCum * 100);
		s += sTemp;
	}
	GetDlgItem(IDC_EDIT_STATS)->SetWindowText(s);
	GetDlgItem(IDC_BUTTON_GO)->SetWindowText("Go!");
	GetDlgItem(IDC_EDIT_BYTES_REQD)->EnableWindow(TRUE);
}
